<script setup>
import { toRef, watch } from "vue";
import { useField } from "vee-validate";
import { BFormInput } from "bootstrap-vue";
import vSelect from "vue-select";
const props = defineProps({
  type: {
    type: String,
    default: "text",
  },
  value: {
    type: [Number, String, Array],
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: null,
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  maxlength: {
    type: Number,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  successMessage: {
    type: String,
    default: "",
  },
  placeholder: {
    type: String,
    default: "",
  },
  options: {
    type: Object,
    default: [],
  },

  clearable: {
    type: Boolean,
    default: false,
  },
});
// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, "name");
const value = toRef(props, "value");

const options = toRef(props, "options");

watch([value], () => {
  if (value.value && value.value.length) {
    setValue(value.value);
  } else {
    setState({
      value: [],
      touched: false,
      errors: [],
    });
  }
});

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {
  value: selectedValue,
  errorMessage,
  handleBlur,
  handleChange,
  setState,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value && props.value.length ? props.value : [],
});
const emit = defineEmits(["change"]);
const setValueOption = (value) => {
  console.log(value);
  handleChange(value);
  setValue(value);
};
const setLastValue = (param) => {
  console.log(selectedValue.value);
  let index = selectedValue.value.indexOf(param);
  console.log(index);
  if (index > -1) {
    selectedValue.value.splice(index, 1);
  }
  let finalValue = [];
  if (selectedValue.value.length > 0) {
    selectedValue.value.map((value) => {
      finalValue.push(value);
    });
  }
  handleChange(finalValue);
  setValue(finalValue);
  emit("change", finalValue);
};
</script>

<template>
  <div
    class="SelectTagInput"
    :class="{ 'has-error': !!errorMessage, success: meta.valid }"
  >
    <label class="d-block" for="designation" v-if="label"
      >{{ label }} <span class="text-danger">*</span></label
    >

    <v-select
      class="eb-select"
      :disabled="disabled"
      :modelValue="selectedValue"
      :name="name"
      :reduce="(val) => val.value"
      :placeholder="placeholder"
      :id="name"
      clearable
      multiple
      taggable
      push-tags
      :class="errorMessage ? 'v-select-input-invalid' : ''"
      :state="errorMessage ? false : null"
      @option:selected="(val) => setValueOption(val)"
      @option:deselected="(val) => setLastValue(val)"
    />
    <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>
  </div>
</template>

<style scoped>
.eb-select {
  margin-bottom: 5px;
}
</style>
